Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -1717,360 +1831,352 @@
        i = nxl
        DO  j = nys, nyn
-          IF ( boundary_flags(j,i) == 6 )  THEN
-          
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                u_comp                 = u(k,j,i) - u_gtrans
-                swap_flux_x_local(k,j) = u_comp * (                           &
-                                         sk(k,j,i) + sk(k,j,i-1)) * 0.5
-                swap_diss_x_local(k,j) = diss_2nd( sk(k,j,i+2), sk(k,j,i+1),  &
-                                                   sk(k,j,i), sk(k,j,i-1),    &
-                                                   sk(k,j,i-1), u_comp,       &
-                                                   0.5, ddx ) 
-             ENDDO
-             
-          ELSE
-          
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                u_comp                 = u(k,j,i) - u_gtrans
-                swap_flux_x_local(k,j) = u_comp*(                              &
-                                         37.0 * ( sk(k,j,i)+sk(k,j,i-1)     )  &
-                                       -  8.0 * ( sk(k,j,i+1) + sk(k,j,i-2) )  &
-                                       +        ( sk(k,j,i+2) + sk(k,j,i-3) ) )&
-                                       * adv_sca_5
-                swap_diss_x_local(k,j) = - ABS( u_comp ) * (                   &
-                                         10.0 * (sk(k,j,i) - sk(k,j,i-1)    )  &
-                                       -  5.0 * ( sk(k,j,i+1) - sk(k,j,i-2) )  &
-                                       +        ( sk(k,j,i+2) - sk(k,j,i-3) ) )&
-                                       * adv_sca_5 
-             ENDDO
-          ENDIF
+
+          DO  k = nzb+1, nzb_max
+
+             u_comp                 = u(k,j,i) - u_gtrans
+             swap_flux_x_local(k,j) = u_comp * (                              &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)   + sk(k,j,i-1)    )         &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j,i+1) + sk(k,j,i-2)    )         &
+                  +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                         ) *         ( sk(k,j,i+2) + sk(k,j,i-3)    )         &
+                                                  )
+
+              swap_diss_x_local(k,j) = -ABS( u_comp ) * (                     &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)   - sk(k,j,i-1)    )         &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j,i+1) - sk(k,j,i-2)  )           &
+                  +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5  &
+                         ) *                                                  &
+                                     ( sk(k,j,i+2) - sk(k,j,i-3) )            &
+                                                           )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp                 = u(k,j,i) - u_gtrans
+             swap_flux_x_local(k,j) = u_comp * (                             &
+                                      37.0 * ( sk(k,j,i)   + sk(k,j,i-1) )   &
+                                    -  8.0 * ( sk(k,j,i+1) + sk(k,j,i-2) )   &
+                                    +        ( sk(k,j,i+2) + sk(k,j,i-3) )   &
+                                                  ) * adv_sca_5
+
+             swap_diss_x_local(k,j) = -ABS( u_comp ) * (                     &
+                                      10.0 * ( sk(k,j,i)   - sk(k,j,i-1) )   &
+                                    -  5.0 * ( sk(k,j,i+1) - sk(k,j,i-2) )   &
+                                    +        ( sk(k,j,i+2) - sk(k,j,i-3) )   &
+                                                          ) * adv_sca_5
+
+          ENDDO
+
        ENDDO
-!
-!--    The following loop computes the horizontal fluxes for the interior of the
-!--    processor domain plus south boundary points. Furthermore tendency terms
-!--    are computed.
+
        DO  i = nxl, nxr
+
           j = nys
-          IF ( boundary_flags(j,i) == 8 )  THEN
-          
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                v_comp               = v(k,j,i) - v_gtrans
-                swap_flux_y_local(k) = v_comp *                                &
-                                       ( sk(k,j,i) + sk(k,j-1,i) ) * 0.5 
-                swap_diss_y_local(k) = diss_2nd( sk(k,j+2,i), sk(k,j+1,i),     &
-                                                 sk(k,j,i), sk(k,j-1,i),       &
-                                                 sk(k,j-1,i), v_comp, 0.5, ddy )
-             ENDDO
-             
-          ELSE
-          
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                v_comp               = v(k,j,i) - v_gtrans
-                swap_flux_y_local(k) = v_comp * (                              &
-                                       37.0 * ( sk(k,j,i) + sk(k,j-1,i)   )    &
-                                     -  8.0 * ( sk(k,j+1,i) + sk(k,j-2,i) )    &
-                                     +        ( sk(k,j+2,i) + sk(k,j-3,i) ) )  &  
-                                     * adv_sca_5
-                swap_diss_y_local(k)= - ABS( v_comp ) * (                      &
-                                      10.0 * ( sk(k,j,i) - sk(k,j-1,i)   )     &
-                                    -  5.0 * ( sk(k,j+1,i) - sk(k,j-2,i) )     &
-                                    +        ( sk(k,j+2,i)-sk(k,j-3,i) ) )     &
-                                    * adv_sca_5
-             ENDDO
-             
-          ENDIF
+          DO  k = nzb+1, nzb_max
+
+             v_comp                  = v(k,j,i) - v_gtrans
+             swap_flux_y_local(k) = v_comp * (                                &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)  + sk(k,j-1,i)     )         &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j+1,i) + sk(k,j-2,i)    )         &
+                  +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                         ) *                                                  &
+                                     ( sk(k,j+2,i) + sk(k,j-3,i)    )         &
+                                             )
+
+             swap_diss_y_local(k) = -ABS( v_comp ) * (                        &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                      +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1  &
+                         ) *                                                  &
+                                     ( sk(k,j,i)   - sk(k,j-1,i)    )         &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                      +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3  &
+                         ) *                                                  &
+                                     ( sk(k,j+1,i) - sk(k,j-2,i)  )           &
+                  +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5  &
+                         ) *                                                  &
+                                     ( sk(k,j+2,i) - sk(k,j-3,i) )            &
+                                                     )
+
+          ENDDO
+!
+!--       Above to the top of the highest topography. No degradation necessary.
+          DO  k = nzb_max+1, nzt
+
+             v_comp               = v(k,j,i) - v_gtrans
+             swap_flux_y_local(k) = v_comp * (                               &
+                                    37.0 * ( sk(k,j,i)   + sk(k,j-1,i) )     &
+                                  -  8.0 * ( sk(k,j+1,i) + sk(k,j-2,i) )     &
+                                  +        ( sk(k,j+2,i) + sk(k,j-3,i) )     &
+                                             ) * adv_sca_5
+              swap_diss_y_local(k) = -ABS( v_comp ) * (                      &
+                                    10.0 * ( sk(k,j,i)   - sk(k,j-1,i) )     &
+                                  -  5.0 * ( sk(k,j+1,i) - sk(k,j-2,i) )     &
+                                  +          sk(k,j+2,i) - sk(k,j-3,i)       &
+                                                      ) * adv_sca_5
+
+          ENDDO
 
           DO  j = nys, nyn
-            IF ( boundary_flags(j,i) /= 0 )  THEN 
-!
-!--            Degrade the order for Dirichlet bc. at the outflow boundary
-               SELECT CASE ( boundary_flags(j,i) )
-               
-                  CASE ( 1 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        u_comp    = u(k,j,i+1) - u_gtrans
-                        flux_r(k) = u_comp * (                                 &
-                                    7.0 * ( sk(k,j,i+1) + sk(k,j,i)   )        &
-                                  -       ( sk(k,j,i+2) + sk(k,j,i-1) ) )      &
-                                  * adv_sca_3
-                        diss_r(k) = - ABS( u_comp ) * (                        &
-                                    3.0 * ( sk(k,j,i+1) - sk(k,j,i)   )        & 
-                                  -       ( sk(k,j,i+2) - sk(k,j,i-1) ) )      &
-                                  * adv_sca_3
-                     ENDDO
-                     
-                  CASE ( 2 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        u_comp    = u(k,j,i+1) - u_gtrans
-                        flux_r(k) = u_comp * ( sk(k,j,i+1) + sk(k,j,i) ) * 0.5
-                        diss_r(k) = diss_2nd( sk(k,j,i+1), sk(k,j,i+1),        &
-                                              sk(k,j,i), sk(k,j,i-1),          &
-                                              sk(k,j,i-2), u_comp, 0.5, ddx )
-                     ENDDO
-                     
-                  CASE ( 3 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        v_comp    = v(k,j+1,i) - v_gtrans
-                        flux_n(k) = v_comp * (                                 &
-                                    7.0 * ( sk(k,j+1,i) + sk(k,j,i)   )        &
-                                  -       ( sk(k,j+2,i) + sk(k,j-1,i) ) )      &
-                                  * adv_sca_3
-                        diss_n(k) = - ABS( v_comp ) * (                        &
-                                    3.0 * ( sk(k,j+1,i) - sk(k,j,i)   )        & 
-                                  -       ( sk(k,j+2,i) - sk(k,j-1,i) ) )      &
-                                  * adv_sca_3
-                     ENDDO
-                     
-                  CASE ( 4 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        v_comp    = v(k,j+1,i) - v_gtrans
-                        flux_n(k) = v_comp * ( sk(k,j+1,i) + sk(k,j,i) ) * 0.5
-                        diss_n(k) = diss_2nd( sk(k,j+1,i), sk(k,j+1,i),        &
-                                              sk(k,j,i), sk(k,j-1,i),          &
-                                              sk(k,j-2,i), v_comp, 0.5, ddy )     
-                     ENDDO
-                     
-                  CASE ( 5 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        u_comp    = u(k,j,i+1) - u_gtrans 
-                        flux_r(k) = u_comp * (                                 &
-                                    7.0 * ( sk(k,j,i+1) + sk(k,j,i)   )        &
-                                  -       ( sk(k,j,i+2) + sk(k,j,i-1) ) )      &
-                                  * adv_sca_3
-                        diss_r(k) = - ABS( u_comp ) * (                        &
-                                    3.0 * ( sk(k,j,i+1) - sk(k,j,i)   )        & 
-                                  -       ( sk(k,j,i+2) - sk(k,j,i-1) ) )      &
-                                  * adv_sca_3
-                     ENDDO  
-                     
-                  CASE ( 6 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        u_comp    = u(k,j,i+1) - u_gtrans
-                        flux_r(k) = u_comp * (                                 &
-                                    7.0 * ( sk(k,j,i+1) + sk(k,j,i)   )        &
-                                  -       ( sk(k,j,i+2) + sk(k,j,i-1) ) )      &
-                                  * adv_sca_3
-                        diss_r(k) = - ABS( u_comp ) * (                        &
-                                    3.0 * ( sk(k,j,i+1) - sk(k,j,i)   )        & 
-                                  -       ( sk(k,j,i+2) - sk(k,j,i-1) ) )      &
-                                  * adv_sca_3
-                     ENDDO
-                     
-                  CASE ( 7 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        v_comp    = v(k,j+1,i) - v_gtrans
-                        flux_n(k) = v_comp * (                                 &
-                                    7.0 * ( sk(k,j+1,i) + sk(k,j,i)   )        &
-                                  -       ( sk(k,j+2,i) + sk(k,j-1,i) ) )      &
-                                  * adv_sca_3
-                        diss_n(k) = - ABS( v_comp ) * (                        &
-                                    3.0 * ( sk(k,j+1,i) - sk(k,j,i)   )        & 
-                                  -       ( sk(k,j+2,i) - sk(k,j-1,i) ) )      &
-                                  * adv_sca_3
-                     ENDDO
-                     
-                  CASE ( 8 )
-                     DO  k = nzb_s_inner(j,i)+1, nzt
-                        v_comp    = v(k,j+1,i) - v_gtrans
-                        flux_n(k) = v_comp * (                                 &
-                                    7.0 * ( sk(k,j+1,i) + sk(k,j,i)   )        &
-                                  -       ( sk(k,j+2,i) + sk(k,j-1,i) ) )      &
-                                  * adv_sca_3
-                        diss_n(k) = -  ABS( v_comp ) * (                       &
-                                    3.0 * ( sk(k,j+1,i) - sk(k,j,i)   )        & 
-                                  -       ( sk(k,j+2,i) - sk(k,j-1,i) ) )      &
-                                  * adv_sca_3
-                     ENDDO  
-                     
-                  CASE DEFAULT
-                  
-               END SELECT
-               
-               IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2 .OR.&
-                   boundary_flags(j,i) == 5 .OR. boundary_flags(j,i) == 6 )    &
-               THEN
-              
-                  DO  k = nzb_s_inner(j,i)+1, nzt
-                     v_comp    = v(k,j+1,i) - v_gtrans
-                     flux_n(k) = v_comp * (                                    &
-                                 37.0 * ( sk(k,j+1,i) + sk(k,j,i)   )          &
-                               -  8.0 * ( sk(k,j+2,i) + sk(k,j-1,i) )          &
-                               +        ( sk(k,j+3,i) + sk(k,j-2,i) ) )        &
-                               * adv_sca_5
-                     diss_n(k) = - ABS( v_comp ) * (                           &
-                                 10.0 * ( sk(k,j+1,i) - sk(k,j,i)   )          &
-                               -  5.0 * ( sk(k,j+2,i) - sk(k,j-1,i) )          &
-                               +        ( sk(k,j+3,i) - sk(k,j-2,i) ) )        &
-                               * adv_sca_5
-                  ENDDO
-                  
-               ELSE
-               
-                  DO  k = nzb_s_inner(j,i)+1, nzt
-                     u_comp    = u(k,j,i+1) - u_gtrans  
-                     flux_r(k) = u_comp * (                                    & 
-                                 37.0 * ( sk(k,j,i+1) + sk(k,j,i)   )          &
-                               -  8.0 * ( sk(k,j,i+2) + sk(k,j,i-1) )          &
-                               +        ( sk(k,j,i+3) + sk(k,j,i-2) ) )        &
-                               * adv_sca_5
-                     diss_r(k) = - ABS( u_comp ) * (                           &
-                                 10.0 * ( sk(k,j,i+1) - sk(k,j,i)   )          &
-                               -  5.0 * ( sk(k,j,i+2) - sk(k,j,i-1) )          &
-                               +        ( sk(k,j,i+3) - sk(k,j,i-2) ) )        &
-                               * adv_sca_5
-                  ENDDO
-                  
-               ENDIF      
-            
-            ELSE
-            
-               DO  k = nzb_s_inner(j,i)+1, nzt
-                  u_comp    = u(k,j,i+1) - u_gtrans
-                  flux_r(k) = u_comp * (                                       &
-                              37.0 * ( sk(k,j,i+1) + sk(k,j,i)   )             &
-                            -  8.0 * ( sk(k,j,i+2) + sk(k,j,i-1) )             &
-                            +        ( sk(k,j,i+3) + sk(k,j,i-2) ) )           &
-                            * adv_sca_5
-                  diss_r(k) = - ABS( u_comp ) * (                              &
-                              10.0 * ( sk(k,j,i+1) - sk(k,j,i)   )             &
-                            -  5.0 * ( sk(k,j,i+2) - sk(k,j,i-1) )             &
-                            +      ( sk(k,j,i+3) - sk(k,j,i-2) ) )             &
-                            * adv_sca_5
-                  
-                  v_comp    = v(k,j+1,i) - v_gtrans
-                  flux_n(k) = v_comp * (                                       &
-                              37.0 * ( sk(k,j+1,i) + sk(k,j,i)   )             &
-                            -  8.0 * ( sk(k,j+2,i) + sk(k,j-1,i) )             &
-                            +        ( sk(k,j+3,i) + sk(k,j-2,i) ) )           &
-                            * adv_sca_5
-                  diss_n(k) = - ABS( v_comp ) * (                              &
-                              10.0 * ( sk(k,j+1,i) - sk(k,j,i)   )             &
-                            -  5.0 * ( sk(k,j+2,i) - sk(k,j-1,i) )             &
-                            +        ( sk(k,j+3,i) - sk(k,j-2,i) ) )           &
-                            * adv_sca_5                  
-               ENDDO
-               
-            ENDIF
-            
-            DO  k = nzb_s_inner(j,i)+1, nzt
-               tend(k,j,i) = tend(k,j,i) - (                                  &
-                  ( flux_r(k) + diss_r(k)                                     &
-                -   swap_flux_x_local(k,j) - swap_diss_x_local(k,j)   ) * ddx &
-                + ( flux_n(k) + diss_n(k)                                     &
-                -   swap_flux_y_local(k) - swap_diss_y_local(k)       ) * ddy)
-                   
+
+             flux_t(0) = 0.0
+             diss_t(0) = 0.0
+             flux_d    = 0.0
+             diss_d    = 0.0
+
+             DO  k = nzb+1, nzb_max
+
+                u_comp    = u(k,j,i+1) - u_gtrans
+                flux_r(k) = u_comp * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j,i+1) + sk(k,j,i)   )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j,i+2) + sk(k,j,i-1) )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                     ) *     ( sk(k,j,i+3) + sk(k,j,i-2) )                  &
+                                     )
+
+                diss_r(k) = -ABS( u_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),0,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j,i+1) - sk(k,j,i)  )                   &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),1,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j,i+2) - sk(k,j,i-1) )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),2,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k,j,i+3) - sk(k,j,i-2) )                  &
+                                             )
+
+                v_comp    = v(k,j+1,i) - v_gtrans
+                flux_n(k) = v_comp * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j+1,i) + sk(k,j,i)   )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j+2,i) + sk(k,j-1,i) )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k,j+3,i) + sk(k,j-2,i) )                  &
+                                     )
+
+                diss_n(k) = -ABS( v_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),3,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k,j+1,i) - sk(k,j,i)    )                 &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),4,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k,j+2,i) - sk(k,j-1,i)  )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),5,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k,j+3,i) - sk(k,j-2,i) )                  &
+                                             )
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),8,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),6,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),8,1)
+
+
+                flux_t(k) = w(k,j,i) * (                                    &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)  + sk(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i) + sk(k-1,j,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                &
+                                       )
+
+                diss_t(k) = -ABS( w(k,j,i) ) * (                            &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)   - sk(k,j,i)    )               &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i)  - sk(k-1,j,i)  )               &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k_ppp,j,i) - sk(k_mm,j,i) )               &
+                                               )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx             &
+                              + ( v(k,j+1,i) - v(k,j,i)   ) * ddy             &
+                              + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+
+                tend(k,j,i) = tend(k,j,i) - (                                 &
+                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j) -    &
+                          swap_diss_x_local(k,j)            ) * ddx           &
+                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k)   -    &
+                          swap_diss_y_local(k)              ) * ddy           &
+                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
+                                                               ) * ddzw(k)    &
+                                            ) + sk(k,j,i) * div
+
+                swap_flux_y_local(k)   = flux_n(k)
+                swap_diss_y_local(k)   = diss_n(k)
                 swap_flux_x_local(k,j) = flux_r(k)
                 swap_diss_x_local(k,j) = diss_r(k)
+                flux_d                 = flux_t(k)
+                diss_d                 = diss_t(k)
+
+             ENDDO
+
+             DO  k = nzb_max+1, nzt
+
+                u_comp    = u(k,j,i+1) - u_gtrans
+                flux_r(k) = u_comp * (                                      &
+                      37.0 * ( sk(k,j,i+1) + sk(k,j,i)   )                  &
+                    -  8.0 * ( sk(k,j,i+2) + sk(k,j,i-1) )                  &
+                    +        ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
+                diss_r(k) = -ABS( u_comp ) * (                              &
+                      10.0 * ( sk(k,j,i+1) - sk(k,j,i)   )                  &
+                    -  5.0 * ( sk(k,j,i+2) - sk(k,j,i-1) )                  &
+                    +        ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
+
+                v_comp    = v(k,j+1,i) - v_gtrans
+                flux_n(k) = v_comp * (                                      &
+                      37.0 * ( sk(k,j+1,i) + sk(k,j,i)   )                  &
+                    -  8.0 * ( sk(k,j+2,i) + sk(k,j-1,i) )                  &
+                    +        ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
+                diss_n(k) = -ABS( v_comp ) * (                              &
+                      10.0 * ( sk(k,j+1,i) - sk(k,j,i)   )                  &
+                    -  5.0 * ( sk(k,j+2,i) - sk(k,j-1,i) )                  &
+                    +        ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),8,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),6,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),8,1)
+
+                flux_t(k) = w(k,j,i) * (                                    &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)  + sk(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i) + sk(k-1,j,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                &
+                                       )
+
+                diss_t(k) = -ABS( w(k,j,i) ) * (                            &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)   - sk(k,j,i)    )               &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i)  - sk(k-1,j,i)  )               &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k_ppp,j,i) - sk(k_mm,j,i) )               &
+                                               )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities introduced
+!--             by a not sufficient reduction of divergences near topography.
+                div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx             &
+                              + ( v(k,j+1,i) - v(k,j,i)   ) * ddy             &
+                              + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+
+                tend(k,j,i) = tend(k,j,i) - (                                 &
+                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j) -    &
+                          swap_diss_x_local(k,j)            ) * ddx           &
+                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k)   -    &
+                          swap_diss_y_local(k)              ) * ddy           &
+                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
+                                                               ) * ddzw(k)    &
+                                            ) + sk(k,j,i) * div
+
                 swap_flux_y_local(k)   = flux_n(k)
                 swap_diss_y_local(k)   = diss_n(k)
-            ENDDO
+                swap_flux_x_local(k,j) = flux_r(k)
+                swap_diss_x_local(k,j) = diss_r(k)
+                flux_d                 = flux_t(k)
+                diss_d                 = diss_t(k)
+
+             ENDDO
+!
+!--          evaluation of statistics
+             SELECT CASE ( sk_char )
+
+                 CASE ( 'pt' )
+                    DO  k = nzb, nzt
+                       sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)         &
+                        + ( flux_t(k) + diss_t(k) )                          &
+                        *   weight_substep(intermediate_timestep_count)
+                    ENDDO
+                 CASE ( 'sa' )
+                    DO  k = nzb, nzt
+                       sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)         &
+                        + ( flux_t(k) + diss_t(k) )                          &
+                        *   weight_substep(intermediate_timestep_count)
+                    ENDDO
+                 CASE ( 'q' )
+                    DO  k = nzb, nzt
+                       sums_wsqs_ws_l(k,tn) = sums_wsqs_ws_l(k,tn)           &
+                        + ( flux_t(k) + diss_t(k) )                          &
+                        *   weight_substep(intermediate_timestep_count)
+                    ENDDO
+
+              END SELECT
+
          ENDDO
       ENDDO
-
-!
-!--   Vertical advection, degradation of order near surface and top. 
-!--   The fluxes flux_d and diss_d at the surface are 0. Due to reasons of
-!--   statistical evaluation the top flux at the surface should be 0
-      DO  i = nxl, nxr
-         DO  j = nys, nyn
-!
-!--         2nd order scheme (bottom)
-            k=nzb_s_inner(j,i)+1
-!            
-!--         The fluxes flux_d and diss_d at the surface are 0. Due to static
-!--         reasons the top flux at the surface should be 0.
-            flux_t(nzb_s_inner(j,i)) = 0.0
-            diss_t(nzb_s_inner(j,i)) = 0.0
-            flux_d = flux_t(k-1)
-            diss_d = diss_t(k-1)
-            flux_t(k) = w(k,j,i) * ( sk(k+1,j,i) + sk(k,j,i) ) * 0.5
-            diss_t(k) = diss_2nd( sk(k+2,j,i), sk(k+1,j,i), sk(k,j,i),        &
-                                  sk(k,j,i), sk(k,j,i), w(k,j,i),             &
-                                  0.5, ddzw(k) )
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d       ) * ddzw(k)    
-!
-!--         WS3 as an intermediate step (bottom)
-            k         = nzb_s_inner(j,i)+2
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            flux_t(k) = w(k,j,i) * (                                          &
-                        7.0 * ( sk(k+1,j,i) + sk(k,j,i) )                     &
-                       - ( sk(k+2,j,i) + sk(k-1,j,i) ) ) * adv_sca_3 
-            diss_t(k) = - ABS( w(k,j,i) ) * (                                 &
-                        3.0 * ( sk(k+1,j,i) - sk(k,j,i)   )                   & 
-                      -       ( sk(k+2,j,i) - sk(k-1,j,i) ) ) * adv_sca_3
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d       ) * ddzw(k)
-!
-!--         WS5
-            DO  k = nzb_s_inner(j,i)+3, nzt-2
-               flux_d    = flux_t(k-1)
-               diss_d    = diss_t(k-1)
-               flux_t(k) = w(k,j,i) * (                                       &
-                           37.0 * ( sk(k+1,j,i) + sk(k,j,i)   )               &
-                         -  8.0 * ( sk(k+2,j,i) + sk(k-1,j,i) )               &
-                         +        ( sk(k+3,j,i) + sk(k-2,j,i) ) ) * adv_sca_5
-               diss_t(k) = - ABS(w(k,j,i)) * (                                &
-                           10.0 * ( sk(k+1,j,i) -sk(k,j,i)    )               &
-                         -  5.0 * ( sk(k+2,j,i) - sk(k-1,j,i) )               &
-                         +        ( sk(k+3,j,i) - sk(k-2,j,i) ) ) * adv_sca_5
-
-               tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)            &
-                                         -   flux_d    - diss_d     ) * ddzw(k)
-            ENDDO
-!
-!--         WS3 as an intermediate step (top)
-            k         = nzt - 1
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            flux_t(k) = w(k,j,i) * (                                          &
-                        7.0 * ( sk(k+1,j,i) + sk(k,j,i)   )                   &
-                      -       ( sk(k+2,j,i) + sk(k-1,j,i) ) ) * adv_sca_3
-            diss_t(k) = - ABS(w(k,j,i)) * (                                   &
-                        3.0 * ( sk(k+1,j,i) - sk(k,j,i)   )                   & 
-                      -       ( sk(k+2,j,i) - sk(k-1,j,i) ) ) * adv_sca_3
-                        
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d       ) * ddzw(k)
-!
-!--         2nd order scheme (top)
-            k         = nzt
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            flux_t(k) = w(k,j,i) * ( sk(k+1,j,i) + sk(k,j,i) ) * 0.5
-            diss_t(k) = diss_2nd( sk(k+1,j,i), sk(k+1,j,i), sk(k,j,i),        &
-                                  sk(k-1,j,i), sk(k-2,j,i), w(k,j,i),         &
-                                  0.5, ddzw(k) )
-
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d       ) * ddzw(k)
-!
-!--         evaluation of statistics
-            SELECT CASE ( sk_char )
-
-               CASE ( 'pt' )
-                 DO  k = nzb_s_inner(j,i), nzt
-                   sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)                    &
-                      + ( flux_t(k) + diss_t(k) )                             &
-                      *   weight_substep(intermediate_timestep_count)
-                 ENDDO
-               CASE ( 'sa' )
-                 DO  k = nzb_s_inner(j,i), nzt
-                   sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)                    &
-                      + ( flux_t(k) + diss_t(k) )                             &
-                      *   weight_substep(intermediate_timestep_count)
-                 ENDDO
-               CASE ( 'q' )
-                 DO  k = nzb_s_inner(j,i), nzt
-                   sums_wsqs_ws_l(k,tn) = sums_wsqs_ws_l(k,tn)                      &
-                      + ( flux_t(k) + diss_t(k) )                             &
-                      *   weight_substep(intermediate_timestep_count)
-                 ENDDO
-
-            END SELECT
-         ENDDO
-      ENDDO
-
 
     END SUBROUTINE advec_s_ws
